*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*<   THIS IS THE USER PATCH AREA AND IS ALSO IN
*<   A SEPARATE PROGRAM CALLED SOLBIOS (CUSTOMER
*<   BASIC I/O SETUP).
*<
*<        -----W A R N I N G-----
*<   YOU, AS THE CUSTOMER, SHOULD NOT ATTEMPT
*<   TO ALTER THE CODE IN VBIOS.  THIS CODE IS
*<   PROVIDED FOR YOUR USE IN ADVANCED APPLICA-
*<   TIONS ONLY.
*<
*<   THE SOLBIOS IS THE AREA THAT A USER ALTERS
*<   TO MATCH HIS OR HER OWN PARTICULAR I/O
*<   CONFIGURATION.  FOLLOW THE INSTRUCTIONS
*<   IN "BRINGING UP VOS CP/M".
*<
*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


MSIZE    EQU    24          ; MEMORY SIZE.
LOC      EQU    (MSIZE*1024)-512

         ORG    LOC

INIT     JMP    ITLZ        ; INIT. ROUTINE FOR I/O'S
CONST    JMP    CSTAT       ; CONSOLE STATUS ROUTINE
CONIN    JMP    CINP        ; CONSOLE INPUT ROUTINE
CONOUT   JMP    COUT        ; CONSOLE OUTPUT ROUTINE
LIST     JMP    LOUT        ; OUTPUT TO LIST DEVICE
PUNCH    JMP    COUT        ; OUTPUT TO PUNCH DEVICE
READER   JMP    CINP        ; INPUT FROM READER DEVICE
IOBYTE   DB      0          ; INITIAL I/O BYTE
ITLZ     RET
         DS    16

*  CONSOLE STATUS

CSTAT   IN    STATP        ; GET STATUS
       ANI    IRDY         ; CHARACTER READY ?
       MVI    A,0          ; IF NOT RETURN AN
       RNZ                 ; 00 IN ACCUMULATOR
       CMA                 ; IF YES, RETURN AN
       RET                 ; 01 IN ACCUMULATOR
       DS    16            ; SPACE FOR LONGER CSTAT ROUTINE

*  CONSOLE INPUT

CINP   IN    STATP        ; GET STATUS
       ANI    IRDY        ; LOOP FOR
       JNZ    CINP        ; CHARACTER
       IN    DPORT        ; GET CHARACTER
       ANI    07FH        ; STRIP MSB
       RET
       DS    16           ; SPACE FOR LONGER CINP ROUTINE

*  CONSOLE OUTPUT

COUT   MOV    A,C       ; GET CHARACTER
       CPI    0DH       ; IS IT CARRIAGE RETURN ?
       JNZ    STP3      ; IF NOT, OUTPUT IT.
       LDA    CRTEST    ; IF SO, GET LAST CHAR.
       CPI    0DH       ; WAS IT A <CR> ?
       JZ    STP4       ; IF SO,SKIP IT...
STP3   MOV    B,C       ; GET READY FOR SOLOS
       CALL   0C019H    ; OUTPUT IT.
STP4   MOV    A,C       ; GET THIS CHAR. AGAIN
      STA    CRTEST     ; AND SAVE IT FOR NEXT TIME.
      RET
      DS    16          ; SPACE FOR LONGER COUT ROUTINE

*  OUTPUT TO LIST DEVICE

LOUT:   IN    LSTAT        ; GET STATUS
LOUT:   IN    LSTAT        ; GET STATUS
        JNZ    LOUT        ; FOR A CHARACTER
        MOV    A,C         ; GET CHAR. TO ACCUMULATOR
        OUT LDATA          ; OUTPUT CHARACTER
        RET
        DS    16        ; SPACE FOR LONGER LOUT ROUTINE

**************************************************
*
*    PORTS AND STATUS BITS DEFINED
*
**************************************************

STATP   EQU    0FAH        ; CONSOLE STATUS PORT
DPORT   EQU    0FCH        ; CONSOLE DATA PORT
LSTAT   EQU    0F8H        ; LISTER STATUS PORT
LDATA   EQU    0F9H        ; LISTER DATA PORT
IRDY    EQU      1         ; CONSOLE IN MASK BIT
ORDY    EQU    80H         ; CONSOLE OUT MASK BIT
LRDY    EQU    80H         ; LISTER MASK BIT
CRTEST  EQU     $          ; STORAGE FOR LAST CHAR.

        END
